#include<bits/stdc++.h>
using namespace std;
int a[1001][1001];
pair <int,int> p[4]={{0,1},{1,0},{0,-1},{-1,0}};
int main (){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int  m,n,q,br=0,i=0,j=0,d=0,sum=0;
    cin >> m >> n >> q;
    while(br<n*n){
        a[i][j]=m;
        if (i+p[d].first==n || j+p[d].second==n){
            d++;
            d%=4;
        }
        if (i==n-1 && j==0){
            d++;
            d%=4;
        }
        if (a[i+p[d].first][j+p[d].second]!=0){
            d++;
            d%=4;
        }
        if(i==q-1) sum+=a[i][j];
        
        i=i+p[d].first;
        j=j+p[d].second;
        m++;
        br++;
    }
    cout << sum;
    return 0;
}
